Ellipsoids
Date: 2019-10-22

org.jmol.shapespecial

## Class Ellipsoids

- java.lang.Object
- - org.jmol.shape.Shape
  - - org.jmol.shape.AtomShape
    - - org.jmol.shapespecial.Ellipsoids

-     public class Ellipsoids
      extends AtomShape

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `java.util.Map<Tensor,Ellipsoid>` | `atomEllipsoids`
    `private javajs.util.Lst<Ellipsoid>` | `ellipsoidSet`
    `private static int` | `MAX_OBJECT_CLICK_DISTANCE_SQUARED`
    `private static java.lang.String` | `PROPERTY_MODES`
    `private javajs.util.P3i` | `ptXY`
    `private javajs.util.BS` | `selectedAtoms`
    `java.util.Map<java.lang.String,Ellipsoid>` | `simpleEllipsoids`
    `private java.lang.String` | `typeSelected`

    - ### Fields inherited from class org.jmol.shape.AtomShape

      `ac, atoms, bsSizeDefault, colixes, isActive, mad, mads, monomerCount, paletteIDs`

    - ### Fields inherited from class org.jmol.shape.Shape

      `bsColixSet, bsSizeSet, isBioShape, ms, myType, RADIUS_MAX, shapeID, translucentAllowed, translucentLevel, vf, vwr`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Ellipsoids()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `private boolean` | `checkID(java.lang.String thisID)`
    `java.util.Map<java.lang.String,java.lang.Object>` | `checkObjectClicked(int x, int y, int action, javajs.util.BS bsModels, boolean drawPicking)`
    `boolean` | `checkObjectHovered(int x, int y, javajs.util.BS bsModels)`
    `private Ellipsoid` | `findPickedObject(int x, int y, boolean isPicking, javajs.util.BS bsModels)`
    `int` | `getIndexFromName(java.lang.String thisID)`
    `boolean` | `getPropertyData(java.lang.String property, java.lang.Object[] data)`
    `java.lang.String` | `getShapeState()`
    `private void` | `getStateAtoms(javajs.util.SB sb)`
    `private void` | `getStateID(javajs.util.SB sb)`
    `private boolean` | `initEllipsoids(java.lang.Object value)`
    `void` | `initShape()`
    `boolean` | `isActive()`
    `void` | `setAtomClickability()`
    `void` | `setModelVisibilityFlags(javajs.util.BS bsModels)`
    `private void` | `setProp(Ellipsoid e, int mode, java.lang.Object value)`
    `void` | `setProperty(java.lang.String propertyName, java.lang.Object value, javajs.util.BS bs)`
    `protected void` | `setSize(int size, javajs.util.BS bsSelected)`
    `private void` | `setVis(java.util.Map<?,Ellipsoid> ellipsoids, javajs.util.BS bs, Atom[] atoms)`

    - ### Methods inherited from class org.jmol.shape.AtomShape

      `checkColixLength, getInfoAsString, getSize, initModelSet, setColixAndPalette, setPropAS, setSize2, setSizeRD, setSizeRD2`

    - ### Methods inherited from class org.jmol.shape.Shape

      `appendCmd, checkBoundsMinMax, checkObjectDragged, coordinateInRange, encodeColor, findNearestAtomIndex, getColix, getColixA, getColixB, getColixI, getColorCommand, getColorCommandUnk, getFontCommand, getProperty, getPropShape, getShapeDetail, getSizeG, getTranslucentLabel, initializeShape, replaceGroup, setModelSet, setPropS, setShapeSizeRD, wasClicked`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### MAX_OBJECT_CLICK_DISTANCE_SQUARED

          private static final int MAX_OBJECT_CLICK_DISTANCE_SQUARED

      See Also:
        Constant Field Values

    - #### ptXY

          private final javajs.util.P3i ptXY

    - #### PROPERTY_MODES

          private static final java.lang.String PROPERTY_MODES

      See Also:
        Constant Field Values

    - #### simpleEllipsoids

          public java.util.Map<java.lang.String,Ellipsoid> simpleEllipsoids

    - #### atomEllipsoids

          public java.util.Map<Tensor,Ellipsoid> atomEllipsoids

    - #### typeSelected

          private java.lang.String typeSelected

    - #### selectedAtoms

          private javajs.util.BS selectedAtoms

    - #### ellipsoidSet

          private javajs.util.Lst<Ellipsoid> ellipsoidSet

  - ### Constructor Detail

    - #### Ellipsoids

          public Ellipsoids()

  - ### Method Detail

    - #### checkObjectHovered

          public boolean checkObjectHovered(int x,
                                            int y,
                                            javajs.util.BS bsModels)

      Overrides:
        `checkObjectHovered` in class `Shape`
      Returns:
        T/F

    - #### checkObjectClicked

          public java.util.Map<java.lang.String,java.lang.Object> checkObjectClicked(int x,
                                                                                     int y,
                                                                                     int action,
                                                                                     javajs.util.BS bsModels,
                                                                                     boolean drawPicking)

      Overrides:
        `checkObjectClicked` in class `Shape`
        `drawPicking` - TODO
      Returns:
        Hashtable containing information about pt clicked

    - #### findPickedObject

          private Ellipsoid findPickedObject(int x,
                                             int y,
                                             boolean isPicking,
                                             javajs.util.BS bsModels)

      Parameters:
        `x` -
        `y` -
        `isPicking` - IGNORED
        `bsModels` -
      Returns:
        true if found

    - #### isActive

          public boolean isActive()

    - #### getIndexFromName

          public int getIndexFromName(java.lang.String thisID)

      Overrides:
        `getIndexFromName` in class `Shape`
      Returns:
        index

    - #### setSize

          protected void setSize(int size,
                                 javajs.util.BS bsSelected)

      Overrides:
        `setSize` in class `AtomShape`

    - #### getPropertyData

          public boolean getPropertyData(java.lang.String property,
                                         java.lang.Object[] data)

      Overrides:
        `getPropertyData` in class `Shape`
      Returns:
        true if serviced

    - #### checkID

          private boolean checkID(java.lang.String thisID)

    - #### initEllipsoids

          private boolean initEllipsoids(java.lang.Object value)

    - #### initShape

          public void initShape()

      Overrides:
        `initShape` in class `AtomShape`

    - #### setProperty

          public void setProperty(java.lang.String propertyName,
                                  java.lang.Object value,
                                  javajs.util.BS bs)

      Specified by:
        `setProperty` in class `Shape`

    - #### setProp

          private void setProp(Ellipsoid e,
                               int mode,
                               java.lang.Object value)

    - #### getShapeState

          public java.lang.String getShapeState()

      Overrides:
        `getShapeState` in class `AtomShape`

    - #### getStateID

          private void getStateID(javajs.util.SB sb)

    - #### getStateAtoms

          private void getStateAtoms(javajs.util.SB sb)

    - #### setModelVisibilityFlags

          public void setModelVisibilityFlags(javajs.util.BS bsModels)

      Overrides:
        `setModelVisibilityFlags` in class `Shape`

    - #### setVis

          private void setVis(java.util.Map<?,Ellipsoid> ellipsoids,
                              javajs.util.BS bs,
                              Atom[] atoms)

    - #### setAtomClickability

          public void setAtomClickability()

      Overrides:
        `setAtomClickability` in class `AtomShape`